Getting Started with TextBox Web Component
Smart UI Web Components work with current evergreen browsers and Node 18+ for local tooling; pin package versions to match your project policy.
Smart UI is distributed as the smart-webcomponents NPM package. You can also use the full download from the Download page.
Quick start
- Install the package:
npm install smart-webcomponents
- Load the TextBox module (ES module script):
<script type="module" src="node_modules/smart-webcomponents/source/modules/smart.textbox.js"></script>
- Add the default stylesheet (prefer angular.json / bundler entry in app codebases; for plain HTML use a link):
<link rel="stylesheet" type="text/css" href="node_modules/smart-webcomponents/source/styles/smart.default.css" />
- Add markup in one of two ways - semantic custom element (the component tag is in your HTML) or a host
div(you mount programmatically with appendTo):
Semantic element (id matches the selector in Smart()):
<smart-text-box id="textbox"></smart-text-box>
Host container (id matches appendTo on Smart.TextBox):
<div id="textboxContainer"></div>
- Initialize after the module loads: define a const textboxOptions object, then either bind with Smart('#textbox', ...) on the semantic tag or use new Smart.TextBox({ ...textboxOptions, appendTo: '#textboxContainer' }) on the host
div:
<script type="module"> import 'node_modules/smart-webcomponents/source/modules/smart.textbox.js'; const textboxOptions = {}; // Option A - semantic <smart-text-box> with id="textbox" Smart('#textbox', class { get properties() { return textboxOptions; } }); // Option B - host div id="textboxContainer" // const textboxInstance = new Smart.TextBox({ // ...textboxOptions, // appendTo: '#textboxContainer' // }); // Option C - constructor(selector, options), then append the returned element yourself // const myTextBox = new Smart.TextBox('#textbox', textboxOptions); // document.body.appendChild(myTextBox); </script>
Uncomment Option B when you use the host
div; use Option A when you use the semantic element. The Runtime cookbook also documents new Smart.TextBox('#textbox', textboxOptions) with appendChild, and document.createElement('smart-text-box') with .props or Object.assign (all are valid patterns; do not combine overlapping patterns for the same instance unless you intend multiple components). - Serve the folder over HTTP (or use your bundler dev server) and open the page.
Runtime cookbook
Alternative creation patterns and imperative APIs. These are all valid ways to create Smart UI components: semantic markup + Smart(); new Smart.TextBox({ ...options, appendTo: '#...' }); new Smart.TextBox('#textbox', textboxOptions) plus appendChild on the returned element; and document.createElement('smart-text-box') then assigning options via .props or Object.assign on the element.
Constructor with a selector string and options, then append the returned element (for example const myTextBox = new Smart.TextBox('#textbox', textboxOptions)):
const textboxOptions = {};
const myTextBox = new Smart.TextBox('#textbox', textboxOptions);
document.body.appendChild(myTextBox);
Create with document.createElement('smart-text-box'), assign properties (same as any custom element), then append:
const textboxOptions = {};
const textbox = document.createElement('smart-text-box');
Object.assign(textbox, textboxOptions);
document.body.appendChild(textbox);
Host on a div with appendTo (import the module, then instantiate when the document is ready; the container id must match appendTo):
import "../../source/modules/smart.textbox.js";
document.readyState === 'complete' ? init() : window.addEventListener('load', init);
function init() {
const textboxOptions = {};
const textbox = new Smart.TextBox({
...textboxOptions,
appendTo: '#textboxContainer'
});
}
Append to the DOM:
const container = document.getElementById('textbox-container');
container.appendChild(textbox);
Remove from the DOM:
textbox.remove();
Set a property:
textbox.disabled = true; textbox.theme = 'dark';
Get a property value:
const isDisabled = textbox.disabled; const currentTheme = textbox.theme;
Invoke a method:
textbox.refresh(); textbox.focus();
Add event listener:
textbox.addEventListener('change', (event) => {
console.log('change triggered:', event.detail.oldValue);
});
Remove event listener:
const handleTextBoxEvent = (event) => {
console.log('change triggered:', event.detail.oldValue);
};
textbox.addEventListener('change', handleTextBoxEvent);
textbox.removeEventListener('change', handleTextBoxEvent);
Accessibility
The TextBox component follows WAI-ARIA best practices:
- Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
- ARIA roles - Appropriate roles and labels are applied automatically
- Focus management - Visible focus indicators for keyboard users
- Screen readers - State changes are announced to assistive technology
- High contrast - Supports Windows High Contrast Mode and forced colors
For custom labeling, set aria-label or aria-labelledby attributes on the component.
Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Angular TextBox - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/textbox/basic

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import TextBoxModule from smart-webcomponents-angular/textbox: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { TextBoxModule } from 'smart-webcomponents-angular/textbox';

4 Root component (standalone)

Add TextBoxModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component, ViewChild, OnInit, AfterViewInit } from '@angular/core';
import { TextBoxComponent } from 'smart-webcomponents-angular/textbox';

import { TextBoxModule } from 'smart-webcomponents-angular/textbox';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [ TextBoxModule ],
  templateUrl: './app.html',
  styleUrl: './app.css'
})

export class App implements AfterViewInit, OnInit {	
	@ViewChild('textbox', { read: TextBoxComponent, static: false }) textbox!: TextBoxComponent;
	
 
	ngOnInit(): void {
		// onInit code.
	}

	ngAfterViewInit(): void {
		// afterViewInit code.
		this.init();
    }
		
	init(): void {
		// init code.
	    

	}	
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smart-text-box as needed:

 <smart-text-box #textbox [selectAllOnFocus]="true" [placeholder]="'smart Text Box'"></smart-text-box>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put TextBoxModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

The demo sources bundled for this widget use standalone only (there is no app.module.ts in that folder). NgModule is fully supported: put TextBoxModule from smart-webcomponents-angular/textbox on NgModule.imports, make your root component non-standalone (remove standalone: true and move widget modules from @Component.imports to the module), and bootstrap with platformBrowserDynamic().bootstrapModule(AppModule).

Minimal main.ts + app.module.ts pairing (adjust paths to match your CLI layout):

src/main.ts

import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { AppModule } from './app/app.module';

platformBrowserDynamic().bootstrapModule(AppModule).catch((err) => console.error(err));

src/app/app.module.ts

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { TextBoxModule } from 'smart-webcomponents-angular/textbox';

@NgModule({
	declarations: [ AppComponent ],
	imports: [ BrowserModule, TextBoxModule ],
	bootstrap: [ AppComponent ]
})
export class AppModule { }

Reuse the template and class logic from steps 4-5 in AppComponent, configured for declarations + NgModule.imports instead of a standalone @Component.

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Accessibility

The TextBox component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.